﻿require "numru/gphys/gphys"

module NumRu
  class GPhys

    def running_mean( dim, nb , missing=true )
      wgt = NArray.sfloat(nb).fill(1.0/nb.to_f)
      self.weighted_running_mean( dim, wgt , missing )
    end

    def weighted_running_mean( dim, wgt , missing=true )
      dum = self.data.val
      val = NArrayMiss.new( typecode , *shape ).fill(0.0)

      dim = dim_index(dim) if dim.is_a?(String)
      dim += rank if dim < 0
      raise ArgumentError,"dim #{dim} does not exist" if dim<0 || dim>=rank

      nb = wgt.length
      nb_2 = (nb-1)/2 if nb%2 == 1
      nb_2 = nb/2     if nb%2 == 0
      kk = NArray.int(nb).indgen(-nb_2,1)

      ki = 0
      kk.each{|k|
    mask = []
    rank.times{|rr|
      if rr==dim
        mask << NArray.int(shape[dim]).indgen(k,1)%shape[dim]
      else
        mask << true
      end
    }
    val += dum[*mask]*wgt[ki]
    ki+=1
      }

      if missing
        mask = []
        rank.times{|rr|
          if rr==dim
            maskdum = NArray.int(nb_2).indgen.to_a
            maskdum << NArray.int(nb_2).indgen(-1,-1).to_a
            mask << maskdum.flatten
          else
            mask << true
          end
        }
        val[*mask] = val[*mask].invalidation
      end

      to_ret = self.copy
      to_ret.data.replace_val( val )
      to_ret
    end

  end
end

